fiftyone.utils.twelvelabs#
TwelveLabs video understanding integration.
This module provides a fiftyone.core.models.Model that wraps the
TwelveLabs video foundation models for video
dataset curation:
Marengo generates 512-dimensional video embeddings (and matching text embeddings), enabling
compute_embeddings(),compute_visualization(), and text-to-videocompute_similarity()searchesPegasus generates natural-language captions/answers about a video
The models run server-side via the TwelveLabs API, so no local GPU is
required. Set your API key via the TWELVELABS_API_KEY environment variable
or pass api_key=... when loading the model.
Classes:
Configuration for running a |
|
|
Wrapper for running inference with TwelveLabs video foundation models. |
- class fiftyone.utils.twelvelabs.TwelveLabsModelConfig(d)#
Bases:
Config,HasZooModelConfiguration for running a
TwelveLabsModel.- Parameters:
operation ("embed") β the operation to perform when the model is applied. Supported values are
"embed"(Marengo video embeddings) and"caption"(Pegasus video captions)api_key (None) β the TwelveLabs API key to use. If not provided, the
TWELVELABS_API_KEYenvironment variable is usedembedding_model ("marengo3.0") β the Marengo model to use for embeddings
analysis_model ("pegasus1.5") β the Pegasus model to use for captioning
prompt (None) β the prompt to use for
"caption"operations. If not provided, a default captioning prompt is usedmax_tokens (512) β the maximum number of tokens to generate for
"caption"operations (must be >= 512)temperature (None) β an optional sampling temperature for captioning
Methods:
Returns a list of class attributes to be serialized.
builder()Returns a ConfigBuilder instance for this class.
copy()Returns a deep copy of the object.
custom_attributes([dynamic,Β private])Returns a customizable list of class attributes.
default()Returns the default config instance.
Downloads the published model specified by the config, if necessary.
from_dict(d)Constructs a Config object from a JSON dictionary.
from_json(path,Β *args,Β **kwargs)Constructs a Serializable object from a JSON file.
from_kwargs(**kwargs)Constructs a Config object from keyword arguments.
from_str(s,Β *args,Β **kwargs)Constructs a Serializable object from a JSON string.
Returns the fully-qualified class name string of this object.
init(d)Initializes the published model config.
Loads the default config instance from file.
parse_array(d,Β key[,Β default])Parses a raw array attribute.
parse_bool(d,Β key[,Β default])Parses a boolean value.
parse_categorical(d,Β key,Β choices[,Β default])Parses a categorical JSON field, which must take a value from among the given choices.
parse_dict(d,Β key[,Β default])Parses a dictionary attribute.
parse_int(d,Β key[,Β default])Parses an integer attribute.
parse_mutually_exclusive_fields(fields)Parses a mutually exclusive dictionary of pre-parsed fields, which must contain exactly one field with a truthy value.
parse_number(d,Β key[,Β default])Parses a number attribute.
parse_object(d,Β key,Β cls[,Β default])Parses an object attribute.
parse_object_array(d,Β key,Β cls[,Β default])Parses an array of objects.
parse_object_dict(d,Β key,Β cls[,Β default])Parses a dictionary whose values are objects.
parse_path(d,Β key[,Β default])Parses a path attribute.
parse_raw(d,Β key[,Β default])Parses a raw (arbitrary) JSON field.
parse_string(d,Β key[,Β default])Parses a string attribute.
serialize([reflective])Serializes the object into a dictionary.
to_str([pretty_print])Returns a string representation of this object.
validate_all_or_nothing_fields(fields)Validates a dictionary of pre-parsed fields checking that either all or none of the fields have a truthy value.
write_json(path[,Β pretty_print])Serializes the object and writes it to disk.
- attributes()#
Returns a list of class attributes to be serialized.
This method is called internally by serialize() to determine the class attributes to serialize.
Subclasses can override this method, but, by default, all attributes in vars(self) are returned, minus private attributes, i.e., those starting with β_β. The order of the attributes in this list is preserved when serializing objects, so a common pattern is for subclasses to override this method if they want their JSON files to be organized in a particular way.
- Returns:
a list of class attributes to be serialized
- classmethod builder()#
Returns a ConfigBuilder instance for this class.
- copy()#
Returns a deep copy of the object.
- Returns:
a Serializable instance
- custom_attributes(dynamic=False, private=False)#
Returns a customizable list of class attributes.
By default, all attributes in vars(self) are returned, minus private attributes (those starting with β_β).
- Parameters:
dynamic β whether to include dynamic properties, e.g., those defined by getter/setter methods or the @property decorator. By default, this is False
private β whether to include private properties, i.e., those starting with β_β. By default, this is False
- Returns:
a list of class attributes
- classmethod default()#
Returns the default config instance.
By default, this method instantiates the class from an empty dictionary, which will only succeed if all attributes are optional. Otherwise, subclasses should override this method to provide the desired default configuration.
- download_model_if_necessary()#
Downloads the published model specified by the config, if necessary.
After this method is called, the model_path attribute will always contain the path to the model on disk.
- classmethod from_dict(d)#
Constructs a Config object from a JSON dictionary.
Config subclass constructors accept JSON dictionaries, so this method simply passes the dictionary to cls().
- Parameters:
d β a dict of fields expected by cls
- Returns:
an instance of cls
- classmethod from_json(path, *args, **kwargs)#
Constructs a Serializable object from a JSON file.
Subclasses may override this method, but, by default, this method simply reads the JSON and calls from_dict(), which subclasses must implement.
- Parameters:
path β the path to the JSON file on disk
*args β optional positional arguments for self.from_dict()
**kwargs β optional keyword arguments for self.from_dict()
- Returns:
an instance of the Serializable class
- classmethod from_kwargs(**kwargs)#
Constructs a Config object from keyword arguments.
- Parameters:
**kwargs β keyword arguments that define the fields expected by cls
- Returns:
an instance of cls
- classmethod from_str(s, *args, **kwargs)#
Constructs a Serializable object from a JSON string.
Subclasses may override this method, but, by default, this method simply parses the string and calls from_dict(), which subclasses must implement.
- Parameters:
s β a JSON string representation of a Serializable object
*args β optional positional arguments for self.from_dict()
**kwargs β optional keyword arguments for self.from_dict()
- Returns:
an instance of the Serializable class
- classmethod get_class_name()#
Returns the fully-qualified class name string of this object.
- init(d)#
Initializes the published model config.
This method should be called by ModelConfig.__init__(), and it performs the following tasks:
Parses the model_name and model_path parameters
Populates any default parameters in the provided ModelConfig dict
- Parameters:
d β a ModelConfig dict
- Returns:
a ModelConfig dict with any default parameters populated
- classmethod load_default()#
Loads the default config instance from file.
Subclasses must implement this method if they intend to support default instances.
- static parse_array(d, key, default=<eta.core.config.NoDefault object>)#
Parses a raw array attribute.
- Parameters:
d β a JSON dictionary
key β the key to parse
default β a default list to return if key is not present
- Returns:
a list of raw (untouched) values
- Raises:
ConfigError β if the field value was the wrong type or no default value was provided and the key was not found in the dictionary
- static parse_bool(d, key, default=<eta.core.config.NoDefault object>)#
Parses a boolean value.
- Parameters:
d β a JSON dictionary
key β the key to parse
default β a default bool to return if key is not present
- Returns:
True/False
- Raises:
ConfigError β if the field value was the wrong type or no default value was provided and the key was not found in the dictionary
- static parse_categorical(d, key, choices, default=<eta.core.config.NoDefault object>)#
Parses a categorical JSON field, which must take a value from among the given choices.
- Parameters:
d β a JSON dictionary
key β the key to parse
choices β either an iterable of possible values or an enum-like class whose attributes define the possible values
default β a default value to return if key is not present
- Returns:
the raw (untouched) value of the given field, which is equal to a value from choices
- Raises:
ConfigError β if the key was present in the dictionary but its value was not an allowed choice, or if no default value was provided and the key was not found in the dictionary
- static parse_dict(d, key, default=<eta.core.config.NoDefault object>)#
Parses a dictionary attribute.
- Parameters:
d β a JSON dictionary
key β the key to parse
default β a default dict to return if key is not present
- Returns:
a dictionary
- Raises:
ConfigError β if the field value was the wrong type or no default value was provided and the key was not found in the dictionary
- static parse_int(d, key, default=<eta.core.config.NoDefault object>)#
Parses an integer attribute.
- Parameters:
d β a JSON dictionary
key β the key to parse
default β a default integer value to return if key is not present
- Returns:
an int
- Raises:
ConfigError β if the field value was the wrong type or no default value was provided and the key was not found in the dictionary
- static parse_mutually_exclusive_fields(fields)#
Parses a mutually exclusive dictionary of pre-parsed fields, which must contain exactly one field with a truthy value.
- Parameters:
fields β a dictionary of pre-parsed fields
- Returns:
the (field, value) that was set
- Raises:
ConfigError β if zero or more than one truthy value was found
- static parse_number(d, key, default=<eta.core.config.NoDefault object>)#
Parses a number attribute.
- Parameters:
d β a JSON dictionary
key β the key to parse
default β a default numeric value to return if key is not present
- Returns:
a number (e.g. int, float)
- Raises:
ConfigError β if the field value was the wrong type or no default value was provided and the key was not found in the dictionary
- static parse_object(d, key, cls, default=<eta.core.config.NoDefault object>)#
Parses an object attribute.
The value of d[key] can be either an instance of cls or a serialized dict from an instance of cls.
- Parameters:
d β a JSON dictionary
key β the key to parse
cls β the class of d[key]
default β a default cls instance to return if key is not present
- Returns:
an instance of cls
- Raises:
ConfigError β if the field value was the wrong type or no default value was provided and the key was not found in the dictionary
- static parse_object_array(d, key, cls, default=<eta.core.config.NoDefault object>)#
Parses an array of objects.
The values in d[key] can be either instances of cls or serialized dicts from instances of cls.
- Parameters:
d β a JSON dictionary
key β the key to parse
cls β the class of the elements of list d[key]
default β the default list to return if key is not present
- Returns:
a list of cls instances
- Raises:
ConfigError β if the field value was the wrong type or no default value was provided and the key was not found in the dictionary
- static parse_object_dict(d, key, cls, default=<eta.core.config.NoDefault object>)#
Parses a dictionary whose values are objects.
The values in d[key] can be either instances of cls or serialized dicts from instances of cls.
- Parameters:
d β a JSON dictionary
key β the key to parse
cls β the class of the values of dictionary d[key]
default β the default dict of cls instances to return if key is not present
- Returns:
a dictionary whose values are cls instances
- Raises:
ConfigError β if the field value was the wrong type or no default value was provided and the key was not found in the dictionary
- static parse_path(d, key, default=<eta.core.config.NoDefault object>)#
Parses a path attribute.
The path is converted to an absolute path if necessary via
os.path.abspath(os.path.expanduser(value)).- Parameters:
d β a JSON dictionary
key β the key to parse
default β a default string to return if key is not present
- Returns:
a path string
- Raises:
ConfigError β if the field value was the wrong type or no default value was provided and the key was not found in the dictionary
- static parse_raw(d, key, default=<eta.core.config.NoDefault object>)#
Parses a raw (arbitrary) JSON field.
- Parameters:
d β a JSON dictionary
key β the key to parse
default β a default value to return if key is not present
- Returns:
the raw (untouched) value of the given field
- Raises:
ConfigError β if no default value was provided and the key was not found in the dictionary
- static parse_string(d, key, default=<eta.core.config.NoDefault object>)#
Parses a string attribute.
- Parameters:
d β a JSON dictionary
key β the key to parse
default β a default string to return if key is not present
- Returns:
a string
- Raises:
ConfigError β if the field value was the wrong type or no default value was provided and the key was not found in the dictionary
- serialize(reflective=False)#
Serializes the object into a dictionary.
Serialization is applied recursively to all attributes in the object, including element-wise serialization of lists and dictionary values.
- Parameters:
reflective β whether to include reflective attributes when serializing the object. By default, this is False
- Returns:
a JSON dictionary representation of the object
- to_str(pretty_print=True, **kwargs)#
Returns a string representation of this object.
- Parameters:
pretty_print β whether to render the JSON in human readable format with newlines and indentations. By default, this is True
**kwargs β optional keyword arguments for self.serialize()
- Returns:
a string representation of the object
- static validate_all_or_nothing_fields(fields)#
Validates a dictionary of pre-parsed fields checking that either all or none of the fields have a truthy value.
- Parameters:
fields β a dictionary of pre-parsed fields
- Raises:
ConfigError β if some values are truth and some are not
- write_json(path, pretty_print=False, **kwargs)#
Serializes the object and writes it to disk.
- Parameters:
path β the output path
pretty_print β whether to render the JSON in human readable format with newlines and indentations. By default, this is False
**kwargs β optional keyword arguments for self.serialize()
- class fiftyone.utils.twelvelabs.TwelveLabsModel(config)#
Bases:
Model,EmbeddingsMixin,PromptMixinWrapper for running inference with TwelveLabs video foundation models.
Example usage:
import fiftyone as fo import fiftyone.zoo as foz import fiftyone.brain as fob from fiftyone.utils.twelvelabs import TwelveLabsModel, TwelveLabsModelConfig dataset = foz.load_zoo_dataset("quickstart-video", max_samples=2) # # Video embeddings # # Load directly model = TwelveLabsModel(TwelveLabsModelConfig({"operation": "embed"})) # Load via zoo # model = foz.load_zoo_model("twelvelabs-marengo3.0") dataset.compute_embeddings(model, embeddings_field="twelvelabs") # Text-to-video search index = fob.compute_similarity( dataset, model=model, embeddings="twelvelabs", brain_key="tl_sim", ) view = dataset.sort_by_similarity( "a person riding a bike", brain_key="tl_sim", k=10, ) session = fo.launch_app(view) # # Video captions # # Load directly model = TwelveLabsModel(TwelveLabsModelConfig({"operation": "caption"})) # Load viz zoo # model = foz.load_zoo_model("twelvelabs-pegasus1.5") dataset.apply_model(model, label_field="caption")
- Parameters:
config β a
TwelveLabsModelConfig
Attributes:
The media type processed by the model.
Whether this model can generate embeddings.
Whether this model can generate prompt embeddings.
True/False whether
transforms()may return tensors of different sizes.The preprocessing function that will/must be applied to each input before prediction, or
Noneif no preprocessing is performed.Whether to apply
transforms()during inference (True) or to assume that they have already been applied (False).Whether this model can generate logits for its predictions.
Methods:
predict(arg)Generates a caption for the given video.
embed(arg)Generates a Marengo embedding for the given video.
Returns the embeddings generated by the last forward pass of the model.
embed_prompt(arg)Generates a Marengo text embedding for the given prompt.
embed_all(args)Generates embeddings for the given iterable of data.
embed_prompts(args)Generates embeddings for the given prompts.
from_config(config)Instantiates a Configurable class from a <cls>Config instance.
from_dict(d)Instantiates a Configurable class from a <cls>Config dict.
from_json(json_path)Instantiates a Configurable class from a <cls>Config JSON file.
from_kwargs(**kwargs)Instantiates a Configurable class from keyword arguments defining the attributes of a <cls>Config.
parse(class_name[,Β module_name])Parses a Configurable subclass name string.
predict_all(args)Performs prediction on the given iterable of data.
validate(config)Validates that the given config is an instance of <cls>Config.
- property media_type#
The media type processed by the model.
Supported values are βimageβ and βvideoβ.
- property has_embeddings#
Whether this model can generate embeddings.
This method returns
Falseby default. Models that can generate embeddings should override this via implementing theEmbeddingsMixininterface.
- property can_embed_prompts#
Whether this model can generate prompt embeddings.
This method returns
Falseby default. Models that can generate prompt embeddings should override this via implementing thePromptMixininterface.
- property ragged_batches#
True/False whether
transforms()may return tensors of different sizes. If True, then passing ragged lists of data topredict_all()is not allowed.
- property transforms#
The preprocessing function that will/must be applied to each input before prediction, or
Noneif no preprocessing is performed.
- property preprocess#
Whether to apply
transforms()during inference (True) or to assume that they have already been applied (False).
- predict(arg)#
Generates a caption for the given video.
- Parameters:
arg β an active
eta.core.video.FFmpegVideoReader- Returns:
- embed(arg)#
Generates a Marengo embedding for the given video.
- Parameters:
arg β an active
eta.core.video.FFmpegVideoReader- Returns:
a 512-dimensional 1D numpy array
- get_embeddings()#
Returns the embeddings generated by the last forward pass of the model.
By convention, this method should always return an array whose first axis represents batch size (which will always be 1 when
predict()was last used).- Returns:
a numpy array containing the embedding(s)
- embed_prompt(arg)#
Generates a Marengo text embedding for the given prompt.
This enables text-to-video similarity searches, since Marengo embeds text and video into a shared space.
- Parameters:
arg β the text prompt
- Returns:
a 512-dimensional 1D numpy array
- embed_all(args)#
Generates embeddings for the given iterable of data.
Subclasses can override this method to increase efficiency, but, by default, this method simply iterates over the data and applies
embed()to each.- Parameters:
args β an iterable of data. See
predict_all()for details- Returns:
a numpy array containing the embeddings stacked along axis 0
- embed_prompts(args)#
Generates embeddings for the given prompts.
Subclasses can override this method to increase efficiency, but, by default, this method simply iterates over the data and applies
embed_prompt()to each.- Parameters:
args β an iterable of prompts
- Returns:
a numpy array containing the embeddings stacked along axis 0
- classmethod from_config(config)#
Instantiates a Configurable class from a <cls>Config instance.
- classmethod from_dict(d)#
Instantiates a Configurable class from a <cls>Config dict.
- Parameters:
d β a dict to construct a <cls>Config
- Returns:
an instance of cls
- classmethod from_json(json_path)#
Instantiates a Configurable class from a <cls>Config JSON file.
- Parameters:
json_path β path to a JSON file for type <cls>Config
- Returns:
an instance of cls
- classmethod from_kwargs(**kwargs)#
Instantiates a Configurable class from keyword arguments defining the attributes of a <cls>Config.
- Parameters:
**kwargs β keyword arguments that define the fields of a <cls>Config dict
- Returns:
an instance of cls
- property has_logits#
Whether this model can generate logits for its predictions.
This method returns
Falseby default. Models that can generate logits should override this via implementing theLogitsMixininterface.
- static parse(class_name, module_name=None)#
Parses a Configurable subclass name string.
Assumes both the Configurable class and the Config class are defined in the same module. The module containing the classes will be loaded if necessary.
- Parameters:
class_name β a string containing the name of the Configurable class, e.g. βClassNameβ, or a fully-qualified class name, e.g. βeta.core.config.ClassNameβ
module_name β a string containing the fully-qualified module name, e.g. βeta.core.configβ, or None if class_name includes the module name. Set module_name = __name__ to load a class from the calling module
- Returns:
the Configurable class config_cls: the Config class associated with cls
- Return type:
- predict_all(args)#
Performs prediction on the given iterable of data.
Image models should support, at minimum, processing
argsvalues that are either lists of uint8 numpy arrays (HWC) or numpy array tensors (NHWC).Video models should support, at minimum, processing
argsvalues that are lists ofeta.core.video.VideoReaderinstances.Subclasses can override this method to increase efficiency, but, by default, this method simply iterates over the data and applies
predict()to each.- Parameters:
args β an iterable of data
- Returns:
a list of
fiftyone.core.labels.Labelinstances or a list of dicts offiftyone.core.labels.Labelinstances containing the predictions
- classmethod validate(config)#
Validates that the given config is an instance of <cls>Config.
- Raises:
ConfigurableError β if config is not an instance of <cls>Config